package com.axis
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.TimerEvent;
	import flash.external.ExternalInterface;
	import flash.utils.Timer;
	
	public class WatchDog extends EventDispatcher
	{
		public static const RESTART_PLAYER = "restartPlayer"; 
		
		
		public function WatchDog()
		{
			instance = this;
			logTime = new Date();
			init ();
		}
		
		private static var instance ;
		 
		
		public static function getInstance():WatchDog
		{
			return instance;
		}
		
		private var logTime;
		private var watchTime:Timer ;
		private var retry = 0 ;
		private var maxRetry = 3 ;
		
		private function init ()
		{
			watchTime = new Timer ( 15000 , 1  );
			watchTime.addEventListener(TimerEvent.TIMER, watchLog );
			watchTime.start();
		}
		
		public function extract( errorInfo :Object )
		{
			
			
			logTime = new Date();
			
			switch ( errorInfo.code )
			{
				case 55555: 
				{
					errorInfo.message = "LOG 1: " + errorInfo.message ;
					log (errorInfo );
					break;
				}
				case 404:
				{
					//dispatchRestart (errorInfo.code);
					break;
				}
				case 731 :
				{
					dispatchRestart (errorInfo.code);
					break;
				}
				default :
				{
					errorInfo.message = "ERROR MESSAGE : " + errorInfo.message ;
					log (errorInfo );
				}
			}
		}
		
		
		public function log (errorInfo )
		{
			var functionName:String = "LocomoteMap['" + Player.locomoteID + "'].__playerEvent";
			errorInfo.message = errorInfo.message  
			ExternalInterface.call(functionName, "error", errorInfo);
		}
		
		private function watchLog ( e :TimerEvent)
		{
			var currentLogTime = new Date();
			var timeDiff =  Number ( currentLogTime - logTime )  ;
			
			if ( timeDiff > 15000){
				logTime = new Date();				
				dispatchRestart ( "TIMEOUT" );				
			}
			else
			{
				log ({message : "WATCHDOG LOG - LISTENING TO CONNECTION" , code : "5" } )
			}
		}
		
		public function keepAlive ()
		{
			logTime = new Date();
		}
		
		private function dispatchRestart ( code )
		{
			if (retry < maxRetry){
				log ({message : "WATCHDOG DETECTED TROUBLE IN STREAMING - RETRYING ATTEMPT " + retry + " ... " , code: code} )
				//dispatchEvent( new Event( RESTART_PLAYER) );
				var functionName:String = "LocomoteMap['" + Player.locomoteID + "'].__playerEvent";
				 
				ExternalInterface.call(functionName, "restartPlayer" );
				retry++ ;
			}
			else
			{
				log ({message : "WATCHDOG ATTEMPTED "+ maxRetry + "  TIMES..SOME SERIOUS PROBLEM WITH NETWORK... " , code: code} )
			}
		}
	}
}


